<center><a href="pbjacobi.c">Actual source code: pbjacobi.c</a></center><br>

<html>
<head>
<title></title>
<meta name="generator" content="c2html 0.9.5">
<meta name="date" content="2007-03-29T00:27:58+00:00">
</head>

<body bgcolor="#FFFFFF">
<pre width="80"><a name="line1">  1: </a><strong><font color="#228B22">#define PETSCKSP_DLL</font></strong>

<a name="line3">  3: </a><font color="#B22222">/* </font>
<a name="line4">  4: </a><font color="#B22222">   Include files needed for the PBJacobi preconditioner:</font>
<a name="line5">  5: </a><font color="#B22222">     pcimpl.h - private include file intended for use by all preconditioners </font>
<a name="line6">  6: </a><font color="#B22222">*/</font>

<a name="line8"> 8: </a> #include <A href="../../../../../include/private/pcimpl.h.html">private/pcimpl.h</A>

<a name="line10"> 10: </a><font color="#B22222">/* </font>
<a name="line11"> 11: </a><font color="#B22222">   Private context (data structure) for the PBJacobi preconditioner.  </font>
<a name="line12"> 12: </a><font color="#B22222">*/</font>
<a name="line13"> 13: </a><font color="#4169E1">typedef</font> <font color="#4169E1">struct</font> {
<a name="line14"> 14: </a>  <A href="../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A> *diag;
<a name="line15"> 15: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>    bs,mbs;
<a name="line16"> 16: </a>} PC_PBJacobi;

<a name="line18"> 18: </a><font color="#B22222">/*</font>
<a name="line19"> 19: </a><font color="#B22222">   Currently only implemented for baij matrices and directly access baij</font>
<a name="line20"> 20: </a><font color="#B22222">  data structures.</font>
<a name="line21"> 21: </a><font color="#B22222">*/</font>
<a name="line22"> 22: </a> #include <A href="../../../../../src/mat/impls/baij/mpi/mpibaij.h.html">src/mat/impls/baij/mpi/mpibaij.h</A>
<a name="line23"> 23: </a> #include <A href="../../../../../src/inline/ilu.h.html">src/inline/ilu.h</A>

<a name="line27"> 27: </a><strong><font color="#4169E1"><a name="PCApply_PBJacobi_2"></a>static <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> PCApply_PBJacobi_2(<A href="../../../../../docs/manualpages/PC/PC.html#PC">PC</A> pc,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> x,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> y)</font></strong>
<a name="line28"> 28: </a>{
<a name="line29"> 29: </a>  PC_PBJacobi    *jac = (PC_PBJacobi*)pc-&gt;data;
<a name="line31"> 31: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       i,m = jac-&gt;mbs;
<a name="line32"> 32: </a>  <A href="../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>    *diag = jac-&gt;diag,x0,x1,*xx,*yy;
<a name="line33"> 33: </a>
<a name="line35"> 35: </a>  <A href="../../../../../docs/manualpages/Vec/VecGetArray.html#VecGetArray">VecGetArray</A>(x,&amp;xx);
<a name="line36"> 36: </a>  <A href="../../../../../docs/manualpages/Vec/VecGetArray.html#VecGetArray">VecGetArray</A>(y,&amp;yy);
<a name="line37"> 37: </a>  <font color="#4169E1">for</font> (i=0; i&lt;m; i++) {
<a name="line38"> 38: </a>    x0 = xx[2*i]; x1 = xx[2*i+1];
<a name="line39"> 39: </a>    yy[2*i]   = diag[0]*x0 + diag[2]*x1;
<a name="line40"> 40: </a>    yy[2*i+1] = diag[1]*x0 + diag[3]*x1;
<a name="line41"> 41: </a>    diag     += 4;
<a name="line42"> 42: </a>  }
<a name="line43"> 43: </a>  <A href="../../../../../docs/manualpages/Vec/VecRestoreArray.html#VecRestoreArray">VecRestoreArray</A>(x,&amp;xx);
<a name="line44"> 44: </a>  <A href="../../../../../docs/manualpages/Vec/VecRestoreArray.html#VecRestoreArray">VecRestoreArray</A>(y,&amp;yy);
<a name="line45"> 45: </a>  <A href="../../../../../docs/manualpages/Profiling/PetscLogFlops.html#PetscLogFlops">PetscLogFlops</A>(6*m);
<a name="line46"> 46: </a>  <font color="#4169E1">return</font>(0);
<a name="line47"> 47: </a>}
<a name="line50"> 50: </a><strong><font color="#4169E1"><a name="PCApply_PBJacobi_3"></a>static <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> PCApply_PBJacobi_3(<A href="../../../../../docs/manualpages/PC/PC.html#PC">PC</A> pc,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> x,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> y)</font></strong>
<a name="line51"> 51: </a>{
<a name="line52"> 52: </a>  PC_PBJacobi    *jac = (PC_PBJacobi*)pc-&gt;data;
<a name="line54"> 54: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       i,m = jac-&gt;mbs;
<a name="line55"> 55: </a>  <A href="../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>    *diag = jac-&gt;diag,x0,x1,x2,*xx,*yy;
<a name="line56"> 56: </a>
<a name="line58"> 58: </a>  <A href="../../../../../docs/manualpages/Vec/VecGetArray.html#VecGetArray">VecGetArray</A>(x,&amp;xx);
<a name="line59"> 59: </a>  <A href="../../../../../docs/manualpages/Vec/VecGetArray.html#VecGetArray">VecGetArray</A>(y,&amp;yy);
<a name="line60"> 60: </a>  <font color="#4169E1">for</font> (i=0; i&lt;m; i++) {
<a name="line61"> 61: </a>    x0 = xx[3*i]; x1 = xx[3*i+1]; x2 = xx[3*i+2];
<a name="line62"> 62: </a>    yy[3*i]   = diag[0]*x0 + diag[3]*x1 + diag[6]*x2;
<a name="line63"> 63: </a>    yy[3*i+1] = diag[1]*x0 + diag[4]*x1 + diag[7]*x2;
<a name="line64"> 64: </a>    yy[3*i+2] = diag[2]*x0 + diag[5]*x1 + diag[8]*x2;
<a name="line65"> 65: </a>    diag     += 9;
<a name="line66"> 66: </a>  }
<a name="line67"> 67: </a>  <A href="../../../../../docs/manualpages/Vec/VecRestoreArray.html#VecRestoreArray">VecRestoreArray</A>(x,&amp;xx);
<a name="line68"> 68: </a>  <A href="../../../../../docs/manualpages/Vec/VecRestoreArray.html#VecRestoreArray">VecRestoreArray</A>(y,&amp;yy);
<a name="line69"> 69: </a>  <A href="../../../../../docs/manualpages/Profiling/PetscLogFlops.html#PetscLogFlops">PetscLogFlops</A>(15*m);
<a name="line70"> 70: </a>  <font color="#4169E1">return</font>(0);
<a name="line71"> 71: </a>}
<a name="line74"> 74: </a><strong><font color="#4169E1"><a name="PCApply_PBJacobi_4"></a>static <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> PCApply_PBJacobi_4(<A href="../../../../../docs/manualpages/PC/PC.html#PC">PC</A> pc,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> x,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> y)</font></strong>
<a name="line75"> 75: </a>{
<a name="line76"> 76: </a>  PC_PBJacobi    *jac = (PC_PBJacobi*)pc-&gt;data;
<a name="line78"> 78: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       i,m = jac-&gt;mbs;
<a name="line79"> 79: </a>  <A href="../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>    *diag = jac-&gt;diag,x0,x1,x2,x3,*xx,*yy;
<a name="line80"> 80: </a>
<a name="line82"> 82: </a>  <A href="../../../../../docs/manualpages/Vec/VecGetArray.html#VecGetArray">VecGetArray</A>(x,&amp;xx);
<a name="line83"> 83: </a>  <A href="../../../../../docs/manualpages/Vec/VecGetArray.html#VecGetArray">VecGetArray</A>(y,&amp;yy);
<a name="line84"> 84: </a>  <font color="#4169E1">for</font> (i=0; i&lt;m; i++) {
<a name="line85"> 85: </a>    x0 = xx[4*i]; x1 = xx[4*i+1]; x2 = xx[4*i+2]; x3 = xx[4*i+3];
<a name="line86"> 86: </a>    yy[4*i]   = diag[0]*x0 + diag[4]*x1 + diag[8]*x2  + diag[12]*x3;
<a name="line87"> 87: </a>    yy[4*i+1] = diag[1]*x0 + diag[5]*x1 + diag[9]*x2  + diag[13]*x3;
<a name="line88"> 88: </a>    yy[4*i+2] = diag[2]*x0 + diag[6]*x1 + diag[10]*x2 + diag[14]*x3;
<a name="line89"> 89: </a>    yy[4*i+3] = diag[3]*x0 + diag[7]*x1 + diag[11]*x2 + diag[15]*x3;
<a name="line90"> 90: </a>    diag     += 16;
<a name="line91"> 91: </a>  }
<a name="line92"> 92: </a>  <A href="../../../../../docs/manualpages/Vec/VecRestoreArray.html#VecRestoreArray">VecRestoreArray</A>(x,&amp;xx);
<a name="line93"> 93: </a>  <A href="../../../../../docs/manualpages/Vec/VecRestoreArray.html#VecRestoreArray">VecRestoreArray</A>(y,&amp;yy);
<a name="line94"> 94: </a>  <A href="../../../../../docs/manualpages/Profiling/PetscLogFlops.html#PetscLogFlops">PetscLogFlops</A>(28*m);
<a name="line95"> 95: </a>  <font color="#4169E1">return</font>(0);
<a name="line96"> 96: </a>}
<a name="line99"> 99: </a><strong><font color="#4169E1"><a name="PCApply_PBJacobi_5"></a>static <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> PCApply_PBJacobi_5(<A href="../../../../../docs/manualpages/PC/PC.html#PC">PC</A> pc,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> x,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> y)</font></strong>
<a name="line100">100: </a>{
<a name="line101">101: </a>  PC_PBJacobi    *jac = (PC_PBJacobi*)pc-&gt;data;
<a name="line103">103: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       i,m = jac-&gt;mbs;
<a name="line104">104: </a>  <A href="../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>    *diag = jac-&gt;diag,x0,x1,x2,x3,x4,*xx,*yy;
<a name="line105">105: </a>
<a name="line107">107: </a>  <A href="../../../../../docs/manualpages/Vec/VecGetArray.html#VecGetArray">VecGetArray</A>(x,&amp;xx);
<a name="line108">108: </a>  <A href="../../../../../docs/manualpages/Vec/VecGetArray.html#VecGetArray">VecGetArray</A>(y,&amp;yy);
<a name="line109">109: </a>  <font color="#4169E1">for</font> (i=0; i&lt;m; i++) {
<a name="line110">110: </a>    x0 = xx[5*i]; x1 = xx[5*i+1]; x2 = xx[5*i+2]; x3 = xx[5*i+3]; x4 = xx[5*i+4];
<a name="line111">111: </a>    yy[5*i]   = diag[0]*x0 + diag[5]*x1 + diag[10]*x2  + diag[15]*x3 + diag[20]*x4;
<a name="line112">112: </a>    yy[5*i+1] = diag[1]*x0 + diag[6]*x1 + diag[11]*x2  + diag[16]*x3 + diag[21]*x4;
<a name="line113">113: </a>    yy[5*i+2] = diag[2]*x0 + diag[7]*x1 + diag[12]*x2 + diag[17]*x3 + diag[22]*x4;
<a name="line114">114: </a>    yy[5*i+3] = diag[3]*x0 + diag[8]*x1 + diag[13]*x2 + diag[18]*x3 + diag[23]*x4;
<a name="line115">115: </a>    yy[5*i+4] = diag[4]*x0 + diag[9]*x1 + diag[14]*x2 + diag[19]*x3 + diag[24]*x4;
<a name="line116">116: </a>    diag     += 25;
<a name="line117">117: </a>  }
<a name="line118">118: </a>  <A href="../../../../../docs/manualpages/Vec/VecRestoreArray.html#VecRestoreArray">VecRestoreArray</A>(x,&amp;xx);
<a name="line119">119: </a>  <A href="../../../../../docs/manualpages/Vec/VecRestoreArray.html#VecRestoreArray">VecRestoreArray</A>(y,&amp;yy);
<a name="line120">120: </a>  <A href="../../../../../docs/manualpages/Profiling/PetscLogFlops.html#PetscLogFlops">PetscLogFlops</A>(45*m);
<a name="line121">121: </a>  <font color="#4169E1">return</font>(0);
<a name="line122">122: </a>}
<a name="line123">123: </a><font color="#B22222">/* -------------------------------------------------------------------------- */</font>
<a name="line126">126: </a><strong><font color="#4169E1"><a name="PCSetUp_PBJacobi"></a>static <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> PCSetUp_PBJacobi(<A href="../../../../../docs/manualpages/PC/PC.html#PC">PC</A> pc)</font></strong>
<a name="line127">127: </a>{
<a name="line128">128: </a>  PC_PBJacobi    *jac = (PC_PBJacobi*)pc-&gt;data;
<a name="line130">130: </a>  <A href="../../../../../docs/manualpages/Sys/PetscMPIInt.html#PetscMPIInt">PetscMPIInt</A>    <A href="../../../../../docs/manualpages/Sys/size.html#size">size</A>;
<a name="line131">131: </a>  <A href="../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>     seqbaij,mpibaij,baij;
<a name="line132">132: </a>  <A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>            A = pc-&gt;pmat;
<a name="line133">133: </a>  Mat_SeqBAIJ    *a;

<a name="line136">136: </a>  <A href="../../../../../docs/manualpages/Sys/PetscTypeCompare.html#PetscTypeCompare">PetscTypeCompare</A>((<A href="../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)pc-&gt;pmat,<A href="../../../../../docs/manualpages/Mat/MATSEQBAIJ.html#MATSEQBAIJ">MATSEQBAIJ</A>,&amp;seqbaij);
<a name="line137">137: </a>  <A href="../../../../../docs/manualpages/Sys/PetscTypeCompare.html#PetscTypeCompare">PetscTypeCompare</A>((<A href="../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)pc-&gt;pmat,<A href="../../../../../docs/manualpages/Mat/MATMPIBAIJ.html#MATMPIBAIJ">MATMPIBAIJ</A>,&amp;mpibaij);
<a name="line138">138: </a>  <A href="../../../../../docs/manualpages/Sys/PetscTypeCompare.html#PetscTypeCompare">PetscTypeCompare</A>((<A href="../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)pc-&gt;pmat,<A href="../../../../../docs/manualpages/Mat/MATBAIJ.html#MATBAIJ">MATBAIJ</A>,&amp;baij);
<a name="line139">139: </a>  <font color="#4169E1">if</font> (!seqbaij &amp;&amp; !mpibaij &amp;&amp; !baij) {
<a name="line140">140: </a>    <A href="../../../../../docs/manualpages/Sys/SETERRQ.html#SETERRQ">SETERRQ</A>(PETSC_ERR_SUP,<font color="#666666">"Currently only supports BAIJ matrices"</font>);
<a name="line141">141: </a>  }
<a name="line142">142: </a>  <A href="http://www.mcs.anl.gov/mpi/www/www3/MPI_Comm_size.html#MPI_Comm_size">MPI_Comm_size</A>(pc-&gt;<A href="../../../../../docs/manualpages/Sys/comm.html#comm">comm</A>,&amp;<A href="../../../../../docs/manualpages/Sys/size.html#size">size</A>);
<a name="line143">143: </a>  <font color="#4169E1">if</font> (mpibaij || (baij &amp;&amp; (<A href="../../../../../docs/manualpages/Sys/size.html#size">size</A> &gt; 1))) A = ((Mat_MPIBAIJ*)A-&gt;data)-&gt;A;
<a name="line144">144: </a>  <font color="#4169E1">if</font> (A-&gt;rmap.n != A-&gt;cmap.n) <A href="../../../../../docs/manualpages/Sys/SETERRQ.html#SETERRQ">SETERRQ</A>(PETSC_ERR_SUP,<font color="#666666">"Supported only for square matrices and square storage"</font>);

<a name="line146">146: </a>   <A href="../../../../../docs/manualpages/Mat/MatSeqBAIJInvertBlockDiagonal.html#MatSeqBAIJInvertBlockDiagonal">MatSeqBAIJInvertBlockDiagonal</A>(A);
<a name="line147">147: </a>  a           = (Mat_SeqBAIJ*)A-&gt;data;
<a name="line148">148: </a>  jac-&gt;diag   = a-&gt;idiag;
<a name="line149">149: </a>  jac-&gt;bs     = A-&gt;rmap.bs;
<a name="line150">150: </a>  jac-&gt;mbs    = a-&gt;mbs;
<a name="line151">151: </a>  <font color="#4169E1">switch</font> (jac-&gt;bs){
<a name="line152">152: </a>    <font color="#4169E1">case</font> 2:
<a name="line153">153: </a>      pc-&gt;ops-&gt;apply = PCApply_PBJacobi_2;
<a name="line154">154: </a>      <font color="#4169E1">break</font>;
<a name="line155">155: </a>    <font color="#4169E1">case</font> 3:
<a name="line156">156: </a>      pc-&gt;ops-&gt;apply = PCApply_PBJacobi_3;
<a name="line157">157: </a>      <font color="#4169E1">break</font>;
<a name="line158">158: </a>    <font color="#4169E1">case</font> 4:
<a name="line159">159: </a>      pc-&gt;ops-&gt;apply = PCApply_PBJacobi_4;
<a name="line160">160: </a>      <font color="#4169E1">break</font>;
<a name="line161">161: </a>    <font color="#4169E1">case</font> 5:
<a name="line162">162: </a>      pc-&gt;ops-&gt;apply = PCApply_PBJacobi_5;
<a name="line163">163: </a>      <font color="#4169E1">break</font>;
<a name="line164">164: </a><strong><font color="#FF0000">    default:</font></strong>
<a name="line165">165: </a>      <A href="../../../../../docs/manualpages/Sys/SETERRQ1.html#SETERRQ1">SETERRQ1</A>(PETSC_ERR_SUP,<font color="#666666">"not supported for block <A href="../../../../../docs/manualpages/Sys/size.html#size">size</A> %D"</font>,jac-&gt;bs);
<a name="line166">166: </a>  }

<a name="line168">168: </a>  <font color="#4169E1">return</font>(0);
<a name="line169">169: </a>}
<a name="line170">170: </a><font color="#B22222">/* -------------------------------------------------------------------------- */</font>
<a name="line173">173: </a><strong><font color="#4169E1"><a name="PCDestroy_PBJacobi"></a>static <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> PCDestroy_PBJacobi(<A href="../../../../../docs/manualpages/PC/PC.html#PC">PC</A> pc)</font></strong>
<a name="line174">174: </a>{
<a name="line175">175: </a>  PC_PBJacobi    *jac = (PC_PBJacobi*)pc-&gt;data;

<a name="line179">179: </a>  <font color="#B22222">/*</font>
<a name="line180">180: </a><font color="#B22222">      Free the private data structure that was hanging off the <A href="../../../../../docs/manualpages/PC/PC.html#PC">PC</A></font>
<a name="line181">181: </a><font color="#B22222">  */</font>
<a name="line182">182: </a>  <A href="../../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(jac);
<a name="line183">183: </a>  <font color="#4169E1">return</font>(0);
<a name="line184">184: </a>}
<a name="line185">185: </a><font color="#B22222">/* -------------------------------------------------------------------------- */</font>
<a name="line186">186: </a><font color="#B22222">/*MC</font>
<a name="line187">187: </a><font color="#B22222">     <A href="../../../../../docs/manualpages/PC/PCPBJACOBI.html#PCPBJACOBI">PCPBJACOBI</A> - Point block Jacobi</font>

<a name="line189">189: </a><font color="#B22222">   Level: beginner</font>

<a name="line191">191: </a><font color="#B22222">  Concepts: point block Jacobi</font>

<a name="line193">193: </a><font color="#B22222">   Notes: Only implemented for the BAIJ matrix formats.</font>

<a name="line195">195: </a><font color="#B22222">.seealso:  <A href="../../../../../docs/manualpages/PC/PCCreate.html#PCCreate">PCCreate</A>(), <A href="../../../../../docs/manualpages/PC/PCSetType.html#PCSetType">PCSetType</A>(), <A href="../../../../../docs/manualpages/PC/PCType.html#PCType">PCType</A> (for list of available types), <A href="../../../../../docs/manualpages/PC/PC.html#PC">PC</A></font>

<a name="line197">197: </a><font color="#B22222">M*/</font>

<a name="line202">202: </a><strong><font color="#4169E1"><a name="PCCreate_PBJacobi"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  PCCreate_PBJacobi(<A href="../../../../../docs/manualpages/PC/PC.html#PC">PC</A> pc)</font></strong>
<a name="line203">203: </a>{
<a name="line204">204: </a>  PC_PBJacobi    *jac;


<a name="line209">209: </a>  <font color="#B22222">/*</font>
<a name="line210">210: </a><font color="#B22222">     Creates the private data structure for this preconditioner and</font>
<a name="line211">211: </a><font color="#B22222">     attach it to the <A href="../../../../../docs/manualpages/PC/PC.html#PC">PC</A> object.</font>
<a name="line212">212: </a><font color="#B22222">  */</font>
<a name="line213">213: </a>  <A href="../../../../../docs/manualpages/Sys/PetscNew.html#PetscNew">PetscNew</A>(PC_PBJacobi,&amp;jac);
<a name="line214">214: </a>  pc-&gt;data  = (void*)jac;

<a name="line216">216: </a>  <font color="#B22222">/*</font>
<a name="line217">217: </a><font color="#B22222">     Logs the memory usage; this is not needed but allows PETSc to </font>
<a name="line218">218: </a><font color="#B22222">     monitor how much memory is being used for various purposes.</font>
<a name="line219">219: </a><font color="#B22222">  */</font>
<a name="line220">220: </a>  PetscLogObjectMemory(pc,<font color="#4169E1">sizeof</font>(PC_PBJacobi));

<a name="line222">222: </a>  <font color="#B22222">/*</font>
<a name="line223">223: </a><font color="#B22222">     Initialize the pointers to vectors to ZERO; these will be used to store</font>
<a name="line224">224: </a><font color="#B22222">     diagonal entries of the matrix for fast preconditioner application.</font>
<a name="line225">225: </a><font color="#B22222">  */</font>
<a name="line226">226: </a>  jac-&gt;diag          = 0;

<a name="line228">228: </a>  <font color="#B22222">/*</font>
<a name="line229">229: </a><font color="#B22222">      Set the pointers for the functions that are provided above.</font>
<a name="line230">230: </a><font color="#B22222">      Now when the user-level routines (such as <A href="../../../../../docs/manualpages/PC/PCApply.html#PCApply">PCApply</A>(), <A href="../../../../../docs/manualpages/PC/PCDestroy.html#PCDestroy">PCDestroy</A>(), etc.)</font>
<a name="line231">231: </a><font color="#B22222">      are called, they will automatically call these functions.  Note we</font>
<a name="line232">232: </a><font color="#B22222">      choose not to provide a couple of these functions since they are</font>
<a name="line233">233: </a><font color="#B22222">      not needed.</font>
<a name="line234">234: </a><font color="#B22222">  */</font>
<a name="line235">235: </a>  pc-&gt;ops-&gt;apply               = 0; <font color="#B22222">/*set depending on the block <A href="../../../../../docs/manualpages/Sys/size.html#size">size</A> */</font>
<a name="line236">236: </a>  pc-&gt;ops-&gt;applytranspose      = 0;
<a name="line237">237: </a>  pc-&gt;ops-&gt;setup               = PCSetUp_PBJacobi;
<a name="line238">238: </a>  pc-&gt;ops-&gt;destroy             = PCDestroy_PBJacobi;
<a name="line239">239: </a>  pc-&gt;ops-&gt;setfromoptions      = 0;
<a name="line240">240: </a>  pc-&gt;ops-&gt;view                = 0;
<a name="line241">241: </a>  pc-&gt;ops-&gt;applyrichardson     = 0;
<a name="line242">242: </a>  pc-&gt;ops-&gt;applysymmetricleft  = 0;
<a name="line243">243: </a>  pc-&gt;ops-&gt;applysymmetricright = 0;
<a name="line244">244: </a>  <font color="#4169E1">return</font>(0);
<a name="line245">245: </a>}


</pre>
</body>

</html>
